default:
    image: ${BUILDER_CONTAINER}:master

stages:
    - build
    - test
    - deploy
    - Release

Build container image:
    tags: ["mintlab"]
    stage: build
    rules:
        - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME
        - if: $CI_COMMIT_TAG =~ /^release\//
        - if: $CI_COMMIT_BRANCH =~ /^(master|production|preprod|development|experimental)$/
    script:
        - /init.sh
        - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" "$CI_REGISTRY"
        - docker buildx build
          --platform ${BUILDKIT_ARCHS:-linux/amd64,linux/arm64}
          --pull
          --output type=registry
          --build-arg BUILD_TIMESTAMP="$(date)"
          --build-arg BUILD_REF="${CI_COMMIT_REF_NAME}"
          --tag ${CI_REGISTRY_IMAGE}:qa-${CI_COMMIT_SHORT_SHA}
          "."

Test:
    tags: ["mintlab"]
    stage: test
    rules:
        - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME
        - if: $CI_COMMIT_TAG =~ /^release\//
        - if: $CI_COMMIT_BRANCH =~ /^(master|production|preprod|development|experimental)$/
    script:
        - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" "$CI_REGISTRY"
        - docker pull "${CI_REGISTRY_IMAGE}:qa-${CI_COMMIT_SHORT_SHA}"
        - docker run --rm "${CI_REGISTRY_IMAGE}:qa-${CI_COMMIT_SHORT_SHA}" prove -lvr t

Deploy container image:
    tags: ["mintlab"]
    rules:
        - if: $CI_COMMIT_TAG =~ /^release\//
        - if: $CI_COMMIT_BRANCH =~ /^(master|production|preprod|development|experimental)$/
    stage: deploy
    script:
        - skopeo login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" "$CI_REGISTRY"
        - skopeo copy --all "docker://${CI_REGISTRY_IMAGE}:qa-${CI_COMMIT_SHORT_SHA}" "docker://${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG}-ci-${CI_PIPELINE_IID}"
#
# Release targets
#

AWS ECR:
    tags: ["mintlab"]
    stage: Release
    rules:
        - if: $ECR_REPOSITORY_URL == null
          when: never
        - if: $CI_MERGE_REQUEST_ID
          when: never
        - if: $CI_COMMIT_TAG =~ /^release\//
    script:
        - $(aws ecr get-login --no-include-email --region "$AWS_ECR_REGION")
        - skopeo login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" "$CI_REGISTRY"
        - skopeo copy --all "docker://$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG-ci-$CI_PIPELINE_IID" "docker://$ECR_REPOSITORY_URL:$CI_COMMIT_REF_SLUG"

GitLab Registry:
    tags: ["mintlab"]
    stage: Release
    rules:
        - if: $CI_MERGE_REQUEST_ID
          when: never
        - if: $CI_COMMIT_TAG =~ /^release\//
    script:
        - skopeo login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" "$CI_REGISTRY"
        - skopeo copy --all "docker://$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG-ci-$CI_PIPELINE_IID" "docker://$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG"
